=== debian/changelog ===
maas (2.1.0~beta2+bzr5454-0ubuntu1) yakkety; urgency=medium

  * MAAS new upstream bugfix release. MAAS 2.1.0b2-bzr5454 (FFe LP: #1629909):
    - [2.1] Bootloaders not downloaded on initial import (LP: #1630394)
    - Cryptic error when PXE-boot requires an image not yet imported (LP: #1611949)
    - [2.0, 2.1, UI] MAAS webui allows boot disk to be changed on an
      already deployed node (LP: #1625676)
    - [2.1] Rename "Networks" tab to "Subnets" (LP: #1630591)
    - [2.1] netaddr assumes MAC OUI is ascii (LP: #1628761)
    - [2.1, 2.0] Can't input dynamic range on "Enable DHCP" after I deleted
      the dynamic range (LP: #1619262)
    - Machine unable to pxe with no-such-image while non-related images are
      being imported (LP: #1612203)
    - External DHCP detection is broken for a variety of reasons (LP: #1628645)
    - [2.1] expected string or bytes-like object (LP: #1627362)
    - [2.1] When trying to release a node, it gets stuck in releasing if
      there is no rack controller to power control (LP: #1614659)
    - WebUI needs a filter for deployed OS (LP: #1445941)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 05 Oct 2016 10:59:45 -0400

maas (2.1.0~beta1+bzr5433-0ubuntu1) yakkety; urgency=medium

  * MAAS new upstream release. MAAS 2.1.0b1-bzr5433 (FFe LP: #1629909):
    - Support for new version of streams.
    - Bootloaders are now downloaded from the streams.
    - Support for Low Latency kernels.
    - Support for new hardware enablement kernels.
    - Device discovery
      - UI ability to Map a network as an action.
      - Ability to select interval of active discovery.
      - Ability to enable active discovery per subnet.
  * Remove old template files on package removal.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Tue, 27 Sep 2016 14:44:26 -0400

maas (2.0.0+bzr5189-0ubuntu1) yakkety; urgency=medium

  * New upstream release, 2.0.0 bzr5189:
    - Cluster Controllers now deprecated. Introducing Rack Controllers.
      + Machine no longer belong to Rack Controllers.
      + High availability it is now supported.
      + Rack Controllers manage DHCP on the Fabric Level.
    - Region Controller high availability and scalability.
      + Ability to configure multiple Region Controller API endpoints.
    - API 1.0 has been deprecated. Introducing new API 2.0.
    - MAAS is introducing IP Ranges and deprecated the Static Range.
      + MAAS now controls the whole subnet.
      + The static Range has now been deprecated.
      + Users can now only create a dynamic or reserved range.
    - MAAS Static Range has been deprecated. MAAS Controls the whole Subnet.
    - New networks GUI.
    - MAAS now fully manages DNS.
    - Extended Storage Support. Includes:
      + XFS, Mount Options, Swap Partitions, tmpfs/ramfs.
    - Adding support for DHCP Snippets.
      + Creates extra custom DHCP config at the Node, Subnet and Global level.
    - MAAS Proxy is now managed by MAAS.
    - Service Tracking. MAAS now tracks status of the several services it runs.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 17 Aug 2016 09:24:17 +0100

maas (2.0.0~rc4+bzr5187-0ubuntu1) yakkety; urgency=medium

  * New upstream release, 2.0.0 RC4 bzr5187:
    - Mirror URL contains double slash (/) after hostname, impacting
      proxy cachaility. (LP: #1592666)
    - [2.0rc2] Static IP address are allowed to be created in a dynamic
      range. (LP: #1604461)
    - When juju adds containers to MAAS, ensure they inherit the parent
      machine domain name, if none is passed by Juju. (LP: #1604461)
    - UI error while generating a MAAS key (token). (LP: #1611342)
    - apiclient.maas_client.MAASClient.post() always sets an op in
      the query string (LP: #1610414)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 27 Jul 2016 22:26:55 -0400

maas (2.0.0~rc3+bzr5180-0ubuntu2) yakkety; urgency=medium

  * Really fix by the determination of the default gateway, otherwise
    automatically chose localhost. (LP: #1607112)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 27 Jul 2016 22:20:09 -0400

maas (2.0.0~rc3+bzr5180-0ubuntu1) yakkety; urgency=medium

  * New upstream release, 2.0.0 RC3 bzr5180:
    - CLI version command doesn't work (2.0) (LP: #1557434)
    - [2.0rc1] MAAS does not respect default subnet's DNS server when
      choosing default DNS (LP: #1576116)
    - [2.0RC1] MAAS displays every power query on the summarized view of
      node event log (LP: #1594991)
    - [2.0] Loading latest machine events can make web browser
      unresponsive (LP: #1598028)
    - [2.0rc1] MAAS doesn't honor DNS settings for a subnet for
      DHCP (LP: #1600720)
    - [2.0rc1] drop arm64/efi grub module workaround (LP: #1600285)
    - maas login yields "ImportError: No module named
      'maasserver'" (LP: #1604169)
    - [doc] events API limit,before, after options not
      documented (LP: #1604901)
    - RackController.get_image_sync_status causes huge load
      on regiond process (LP: #1604465)
    - [2.0b8] MAAS is automatically monitoring timeouts. (LP: #1598149)
    - [2.0] Error messaging about monitor expiry has been
      dropped (LP: #1605252)
    - [2.0rc2] Can't get node-results via cli/api (LP: #1602721)
    - node set to "failed deployment" for no visible reason (LP: #1604962)
    - Event log should always include a reason why a node was
      marked Failed Deployment (LP: #1604987)
  * If no default route is present in the system, configure maas_url on
    regiond.conf to localhost to allow the user to tell MAAS what IP to use.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Fri, 22 Jul 2016 18:05:45 -0400

maas (2.0.0~rc2+bzr5156-0ubuntu1) yakkety; urgency=medium

  * New upstream release, 2.0.0 RC2 bzr5156:
    - Pick up wrong grub.cfg if another filesystem exists (LP: #1582070)
    - [2.0] confusing reverse DNS lookups because MAAS creates multiple
      PTR records (LP: #1599223)
    - [2.0] reverse DNS sometimes assigns FQDN where it should assign

