## maas 2.2.0~rc1+bzr5922

=== Makefile ===
--- 
+++ 
@@ -28,11 +28,9 @@
 
 # MAAS SASS stylesheets. The first input file (maas-styles.css) imports
 # the others, so is treated specially in the target definitions.
-scss_theme := include/nodejs/node_modules/cloud-vanilla-theme
-scss_inputs := \
-    src/maasserver/static/scss/build.scss \
-    $(wildcard src/maasserver/static/scss/*/*.scss) \
-    $(wildcard src/maasserver/static/scss/*/*/*.scss)
+scss_theme := include/nodejs/node_modules/maas-gui-vanilla-theme
+scss_input := src/maasserver/static/scss/build.scss
+scss_deps := $(wildcard src/maasserver/static/scss/_*.scss)
 scss_output := src/maasserver/static/css/build.css
 
 # Prefix commands with this when they need access to the database.
@@ -49,7 +47,7 @@
 export PGDATABASE := maas
 
 # For anything we start, we want to hint as to its root directory.
-export MAAS_ROOT := $(CURDIR)/run
+export MAAS_ROOT := $(CURDIR)/.run
 
 build: \
   bin/buildout \
@@ -61,11 +59,12 @@
   bin/twistd.region \
   bin/test.cli \
   bin/test.rack \
-  bin/test.config \
   bin/test.region \
+  bin/test.region.legacy \
   bin/test.testing \
   bin/test.js \
   bin/test.e2e \
+  bin/test.parallel \
   bin/py bin/ipy \
   $(js_enums)
 
@@ -86,12 +85,6 @@
 
 .gitignore: .bzrignore
 	sed 's:^[.]/:/:' $^ > $@
-	echo '/src/**/*.pyc' >> $@
-	echo '/etc/**/*.pyc' >> $@
-
-run/etc/ntp.conf: templates/ntp.conf
-	@mkdir -p $(@D)
-	@cp templates/ntp.conf $@
 
 configure-buildout:
 	utilities/configure-buildout
@@ -106,8 +99,16 @@
 	$(python) bootstrap-buildout.py --allow-site-packages
 	@touch --no-create $@  # Ensure it's newer than its dependencies.
 
+# buildout.cfg refers to .run and .run-e2e.
+buildout.cfg: .run .run-e2e
+
 bin/database: bin/buildout buildout.cfg versions.cfg setup.py
 	$(buildout) install database
+	@touch --no-create $@
+
+bin/test.parallel: \
+  bin/buildout buildout.cfg versions.cfg setup.py
+	$(buildout) install parallel-test
 	@touch --no-create $@
 
 bin/maas-region bin/twistd.region: \
@@ -122,6 +123,11 @@
 	$(buildout) install region-test
 	@touch --no-create $@
 
+bin/test.region.legacy: \
+    bin/buildout buildout.cfg versions.cfg setup.py $(js_enums)
+	$(buildout) install region-test-legacy
+	@touch --no-create $@
+
 bin/maas: bin/buildout buildout.cfg versions.cfg setup.py
 	$(buildout) install cli
 	@touch --no-create $@
@@ -134,14 +140,15 @@
 	$(buildout) install js-test
 	@touch --no-create $@
 
-bin/test.e2e: bin/protractor bin/buildout buildout.cfg versions.cfg setup.py
+bin/test.e2e: \
+    bin/protractor bin/buildout buildout.cfg versions.cfg setup.py
 	$(buildout) install e2e-test
 	@touch --no-create $@
 
 # bin/maas-region is needed for South migration tests. bin/flake8 is
 # needed for checking lint and bin/sass is needed for checking css.
 bin/test.testing: \
-  bin/maas-region bin/flake8 bin/sass bin/buildout \
+  bin/maas-region bin/flake8 bin/sass $(scss_theme) bin/buildout \
   buildout.cfg versions.cfg setup.py
 	$(buildout) install testing-test
 	@touch --no-create $@
@@ -152,13 +159,8 @@
 	@touch --no-create $@
 
 bin/test.rack: \
-  bin/buildout buildout.cfg versions.cfg setup.py bin/maas-rack \
-  run/etc/ntp.conf
+  bin/buildout buildout.cfg versions.cfg setup.py bin/maas-rack bin/py
 	$(buildout) install rack-test
-	@touch --no-create $@
-
-bin/test.config: bin/buildout buildout.cfg versions.cfg setup.py
-	$(buildout) install config-test
 	@touch --no-create $@
 
 bin/flake8: bin/buildout buildout.cfg versions.cfg setup.py
@@ -211,8 +213,8 @@
 define test-scripts
   bin/test.cli
   bin/test.rack
-  bin/test.config
   bin/test.region
+  bin/test.region.legacy
   bin/test.testing
   bin/test.js
 endef
@@ -224,20 +226,32 @@
 test+lxd: lxd $(strip $(test-scripts))
 	utilities/isolated-make-test
 
-test: $(strip $(test-scripts))
+test: bin/test.parallel bin/coverage
+	@$(RM) .coverage .coverage.*
+	@bin/test.parallel --subprocess-per-core
+	@bin/coverage combine
+
+test-serial: $(strip $(test-scripts))
 	@bin/maas-region makemigrations --dry-run --exit && exit 1 ||:
-	@$(RM) coverage.data .failed
+	@$(RM) .coverage .coverage.* .failed
 	$(foreach test,$^,$(test-template);)
 	@test ! -f .failed
 
 test-failed: $(strip $(test-scripts))
 	@bin/maas-region makemigrations --dry-run --exit && exit 1 ||:
-	@$(RM) coverage.data .failed
+	@$(RM) .coverage .coverage.* .failed
 	$(foreach test,$^,$(test-template-failed);)
 	@test ! -f .failed
 
 clean-failed:
 	$(RM) .noseids
+
+src/maasserver/testing/initial.maas_test.sql: bin/database syncdb
+	bin/database --preserve run -- \
+	    pg_dump maas --no-owner --no-privileges \
+	        --format=plain > $@
+
+test-initial-data: src/maasserver/testing/initial.maas_test.sql
 
 define test-template
 $(test) --with-xunit --xunit-file=xunit.$(notdir $(test)).xml || touch .failed
@@ -253,27 +267,28 @@
 	@bin/maas-region makemigrations --dry-run --exit && exit 1 ||:
 	@bin/test.rack --stop
 
-test+coverage: export NOSE_WITH_COVERAGE = 1
-test+coverage: test
+test-serial+coverage: export NOSE_WITH_COVERAGE = 1
+test-serial+coverage: test-serial
 
 coverage-report: coverage/index.html
 	sensible-browser $< > /dev/null 2>&1 &
 
-coverage.xml: bin/coverage coverage.data
-	bin/coverage xml --include 'src/*' -o $@
+coverage.xml: bin/coverage .coverage
+	bin/coverage xml -o $@
 
 coverage/index.html: revno = $(or $(shell bzr revno 2>/dev/null),???)
-coverage/index.html: bin/coverage coverage.data
+coverage/index.html: bin/coverage .coverage
 	@$(RM) -r $(@D)
-	bin/coverage html --include 'src/*' \
-	    --omit 'src/*/tests/*,src/*/testing/*' \
-	    --title "MAAS r$(revno)" --directory $(@D)
-
-coverage.data:
-	@$(error Use `$(MAKE) test+coverage` to generate coverage data, \
-	    or invoke a test script using the `--with-coverage` flag)
-
-lint: lint-py lint-py-complexity lint-py-imports lint-js lint-doc lint-rst
+	bin/coverage html \
+	    --title "Coverage for MAAS r$(revno)" \
+	    --directory $(@D)
+
+.coverage:
+	@$(error Use `$(MAKE) test` to generate coverage)
+
+lint: \
+    lint-py lint-py-complexity lint-py-imports \
+    lint-js lint-junk lint-doc lint-rst
 
 pocketlint = $(call available,pocketlint,python-pocket-lint)
 
@@ -289,7 +304,7 @@
 lint-py: bin/flake8
 	@find $(sources) -name '*.py' \
 	  ! -path '*/migrations/*' ! -path '*/south_migrations/*' -print0 \
-	    | xargs -r0 bin/flake8 --ignore=E123,E402,E731 --isolated
+	    | xargs -r0 bin/flake8 --ignore=E123,E305,E402,E731 --isolated
 
 # Ignore tests when checking complexity. The maximum complexity ought to
 # be close to 10 but MAAS has many functions that are over that so we
@@ -300,7 +315,7 @@
 	@find $(sources) -name '*.py' \
 	  ! -path '*/migrations/*' ! -path '*/south_migrations/*' \
 	  ! -path '*/tests/*' ! -path '*/testing/*' ! -name 'testing.py' \
-	  -print0 | xargs -r0 bin/flake8 --ignore=E123,E402,E731 \
+	  -print0 | xargs -r0 bin/flake8 --ignore=E123,E305,E402,E731 \
 	              --isolated --max-complexity=$(maximum)
 
 # Statically check imports against policy.
@@ -323,6 +338,11 @@
 	    '(' -name '*.html' -o -name '*.js' ')' -print0 \
 		| xargs -r0 -n20 -P4 $(pocketlint)
 
+# Sometimes junk gets added to MAAS, like .moved files.
+lint-junk:
+	@if bzr ls --recursive --versioned | egrep '[.]moved$$'; then \
+	    echo "^ Junk found. Please remove it from the tree." >&2 ; fi
+
 # Apply automated formatting to all Python files.
 format: sources = $(wildcard *.py contrib/*.py) src templates twisted utilities etc
 format:
@@ -360,23 +380,3 @@
 man/%: docs/man/%.rst | bin/sphinx-build
 	bin/sphinx-build -b man docs man $^
 
-enums: $(js_enums)
-
-$(js_enums): bin/py src/maasserver/utils/jsenums.py $(py_enums)
-	bin/py -m maasserver.utils.jsenums $(py_enums) > $@
-
-styles: clean-styles $(scss_output)
-
-$(scss_output): bin/sass $(scss_theme) $(scss_inputs)
-	bin/sass --include-path=src/maasserver/static/scss \
-	    --output-style compressed $(scss_inputs) -o $(dir $@)
-
-$(scss_theme): prefix = include/nodejs
-$(scss_theme):
-	$(npm_install) --prefix $(prefix) cloud-vanilla-theme@0.0.22
-
-clean-styles:
-	$(RM) $(scss_output)
-
-clean: stop clean-run clean-failed
-	find . -type f -name '*.py[co]' -print0 | xargs -r0 $(RM)
