=== debian/changelog ===
maas (2.2.0~rc1+bzr5922-0ubuntu2) zesty; urgency=medium

  * Bump depends version on python3-curtin. (LP: #1680175)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 05 Apr 2017 13:51:58 -0400

maas (2.2.0~rc1+bzr5922-0ubuntu1) zesty; urgency=medium

  * New upstream release, MAAS 2.2.0 RC 1. (FFe LP: #1667141)
  * debian/maas-common.logrotate: Rotate maas.log weekly, instead of daily.
    Store logs for 8 weeks. (LP: #1677005)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Tue, 28 Mar 2017 11:08:38 -0400

maas (2.2.0~beta4+bzr5856-0ubuntu1) zesty; urgency=medium

  * New upstream release, MAAS 2.2.0 Beta 4. (FFe LP: #1667141)
    - Add support to disable components.
    - Improve RSD details page. Show composed machines and power tab.
    - Add NTP & Internet connectivity tests.
    - UX improvements - Change to new tab system to improve navigation.
    - Error surfacing - For interfaces of Machines & Devices.
    - Windows deployments - support to select the root/boot disk.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Thu, 16 Mar 2017 16:10:26 +0000

maas (2.2.0~beta3+bzr5815-0ubuntu1) zesty; urgency=medium

  * New upstream release. MAAS 2.2.0 Beta 3 (FFe LP: #1667141):
    - Introduce storage verification smoke tests.
    - Introduce notifications API.
    - Add device details page.
    - Introduce Wedge BMC discovery during commissioning.
    - Add pod listing & details page.
    - Add dynamic composition for virsh devices.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 15 Feb 2017 08:37:25 -0500

maas (2.2.0~beta2+bzr5717-0ubuntu1) zesty; urgency=medium

  * New upstream release. MAAS 2.2.0 Beta 2 (bzr5717):
    - Introduce initial support for Intel RSD.
    - Introduce IPv6 IPMI auto-discovery.
    - Introduce notifications.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 30 Jan 2017 15:55:02 -0500

maas (2.2.0~beta1+bzr5675-0ubuntu1) zesty; urgency=medium

  * New upstream release. MAAS 2.2.0 Beta 1 (bzr5675):
    - Changing the concept of Spaces to a L2 layer.
    - Support for DHCP relays.
    - Introduce the concept of UNMANAGED subnets.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 11 Jan 2017 13:34:46 +0200

maas (2.2.0~alpha1+bzr5614-0ubuntu1) zesty; urgency=medium

  * New upstream release. MAAS 2.2.0 Alpha 1 (bzr5614):
    - Don't install Django settings into /usr/share/maas/maas. For
      regiond these were squatting the `maas` namespace, preventing its
      use elsewhere (LP: #1646748)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 21 Nov 2016 20:01:31 -0500

maas (2.1.1+bzr5501-0ubuntu1) zesty; urgency=medium

  * MAAS new upstream bugfix release. MAAS 2.1.1 bzr 5544.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 24 Oct 2016 11:28:59 -0400

maas (2.1.0+bzr5480-0ubuntu1) yakkety; urgency=medium

  * MAAS new upstream bugfix release. MAAS 2.1.0 (0-day SRU LP: #1633064):
    - TestPartition.test_get_partition_number_returns_starting_at_2_for_ppc64el
      fails spuriously (LP: #1569365)
    - "Deployed" and "Deploying" are too similar (LP: #1598470)
    - Users' maas api keys do not have a name (LP: #1536354)
    - [2.1] Incorrect logging message - showing SERVICE_STATE.ON (LP: #1631358)
    - [2.1 UI] Images page "Queued for download" is confusing when selections
      are not saved (LP: #1631420)
    - [2.1b1] Dashboard column widths for discovered items are
      wonky (LP: #1631024)
    - [2.1b1] 'Registering existing rack controller' (LP: #1631022)
    - [2.1] Command 'interface link-subnet' does not work (LP: #1629604)
    - [FUJ] SSH input field not indicated for invalid username & the error
      is incomprehensible (LP: #1628114)
    - [2.1 ipv6] DHCP generation should not fail when address-family
      conflicts are present (LP: #1629475)
    - [2.0rc2] Commissioning node with gateway_link_v4 set fails. (LP: #1603466)
    - [2.1, 2.0 UI] Error when using dhcp range with pre-existing dynamic
      reservation (LP: #1608555)
    - [2.1b2] Node failed to be released, because of the following error:
      'NoneType' object has no attribute 'addErrback' (LP: #1632815)
    - [2.1, Yakkety, UI] UI error when adding a chassis (LP: #1632395)
    - [2.0, 2.1 UI] Other reserved IP ranges disappear when one of them is
      deleted on Subnet details page. (LP: #1631079)
    - [2.1b1] MAAS fails to deploy systems with 3+ TB disks (LP: #1630667)
    - [2.1 Yakkety UI] Unable to select nodes (LP: #1630633)
    - [2.0, 2.1] Release and list IPs reserved by another user (LP: #1629061)
    - [2.0rc2] Changing DNSSEC validation does not trigger configuration
      file update (LP: #1605476)
    - [2.1] Failed to mount a partition and it doesn't surface error. (LP: #1631152)
    - [2.1. Yakkety] "Map subnet" action doesn't work. (LP: #1632862)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 05 Oct 2016 21:47:25 -0400

maas (2.1.0~alpha4+bzr5397-0ubuntu1) yakkety; urgency=medium

  * MAAS new upstream release, MAAS 2.1.0 alpha 4 (bzr5397):
    - Complete First User Journey (Ability to import keys from GH/LP).
    - User profile has ability to import keys from GH/LP as well.
    - Device discovery:
      - Ability to clear records that may be incorrect.
      - Ability to 'Map networks' via the API.
    - Import NTP configuration via vendor-data and DHCP.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 19 Sep 2016 17:21:47 -0400

maas (2.1.0~alpha3+bzr5368-0ubuntu1) yakkety; urgency=medium

  * New upstream release, MAAS 2.1.0 Alpha 3 (bzr5363):
    - First user journey (SSH key import not yet available).
    - Allow the user to import SSH keys from LP or GH (only API/CLI).
    - Provide NTP services. Region and Rack Controllers now provide NTP
      services. Machines are also deployed with NTP configuration via.
      + Add cloud-init vendor data to support configuring the machine with
        NTP settings.
    - Images page complete redesign and transition to AngularJS.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 19 Sep 2016 17:21:20 -0400


