=== debian/control ===
--- 
+++ 
@@ -128,7 +128,7 @@
          python3-attr,
          python3-bson,
          python3-crochet,
-         python3-curtin (>> 0.1.0~bzr351),
+         python3-curtin (>> 0.1.0~bzr478),
          python3-distro-info,
          python3-formencode,
          python3-jsonschema,
@@ -242,9 +242,10 @@
          python3-attr,
          python3-convoy,
          python3-crochet,
-         python3-curtin (>> 0.1.0~bzr275),
+         python3-curtin (>> 0.1.0~bzr478),
          python3-lxml,
          python3-maas-client (= ${binary:Version}),
+         python3-markupsafe,
          python3-netaddr,
          python3-psycopg2,
          python3-sphinx,
